<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Plugins Docs Source: control/control.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Plugins Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton.html">ableton/ableton</a></li><li><a href="module-control_control.html">control/control</a></li><li><a href="module-d-pro_d-pro.html">d-pro/d-pro</a></li><li><a href="module-data_data.html">data/data</a></li><li><a href="module-devices_device.html">devices/device</a></li><li><a href="module-devices_devices.html">devices/devices</a></li><li><a href="module-logic_logic.html">logic/logic</a></li><li><a href="module-messenger.html">messenger</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-sound_sound.html">sound/sound</a></li><li><a href="module-telegram_client.html">telegram/client</a></li><li><a href="module-telegram_telegram.html">telegram/telegram</a></li><li><a href="module-time_time.html">time/time</a></li><li><a href="module-tradfri_tradfri.html">tradfri/tradfri</a></li><li><a href="module-twilio_phone.html">twilio/phone</a></li><li><a href="module-twilio_twilio.html">twilio/twilio</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton-Liveset.html">ableton/ableton~Liveset</a></li><li><a href="module-control_control-SessionControl.html">control/control~SessionControl</a></li><li><a href="module-d-pro_d-pro-Show.html">d-pro/d-pro~Show</a></li><li><a href="module-data_data-Data.html">data/data~Data</a></li><li><a href="module-data_data-CollectionAPI.html">data/data~CollectionAPI</a></li><li><a href="module-devices_device-Device.html">devices/device~Device</a></li><li><a href="module-devices_device-UDPdevice.html">devices/device~UDPdevice</a></li><li><a href="module-devices_device-OSCdevice.html">devices/device~OSCdevice</a></li><li><a href="module-devices_device-TCPdevice.html">devices/device~TCPdevice</a></li><li><a href="module-devices_device-Webdevice.html">devices/device~Webdevice</a></li><li><a href="module-devices_device-Serialdevice.html">devices/device~Serialdevice</a></li><li><a href="module-devices_device-Mididevice.html">devices/device~Mididevice</a></li><li><a href="module-logic_logic-Logic.html">logic/logic~Logic</a></li><li><a href="module-logic_logic-Condition.html">logic/logic~Condition</a></li><li><a href="module-logic_logic-Listener.html">logic/logic~Listener</a></li><li><a href="module-logic_logic-PEventListener.html">logic/logic~PEventListener</a></li><li><a href="module-messenger-Messenger.html">messenger~Messenger</a></li><li><a href="module-messenger-Conversation.html">messenger~Conversation</a></li><li><a href="module-messenger-Agent.html">messenger~Agent</a></li><li><a href="module-plugin-Plugin.html">plugin~Plugin</a></li><li><a href="module-plugin-Collection.html">plugin~Collection</a></li><li><a href="module-plugin-Item.html">plugin~Item</a></li><li><a href="module-telegram_client-Agent.html">telegram/client~Agent</a></li><li><a href="module-telegram_client-Client.html">telegram/client~Client</a></li><li><a href="module-telegram_client-Bot.html">telegram/client~Bot</a></li><li><a href="module-telegram_telegram-Telegram.html">telegram/telegram~Telegram</a></li><li><a href="module-telegram_telegram-Conversation.html">telegram/telegram~Conversation</a></li><li><a href="module-telegram_telegram-Dialogue.html">telegram/telegram~Dialogue</a></li><li><a href="module-telegram_telegram-DialogueCondition.html">telegram/telegram~DialogueCondition</a></li><li><a href="module-telegram_telegram-Chat.html">telegram/telegram~Chat</a></li><li><a href="module-telegram_telegram-Message.html">telegram/telegram~Message</a></li><li><a href="module-twilio_phone-Phone.html">twilio/phone~Phone</a></li><li><a href="module-twilio_twilio-Switchboard.html">twilio/twilio~Switchboard</a></li><li><a href="module-twilio_twilio-SmsIn.html">twilio/twilio~SmsIn</a></li><li><a href="module-twilio_twilio-Call.html">twilio/twilio~Call</a></li><li><a href="module-twilio_twilio-CallIn.html">twilio/twilio~CallIn</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: control/control.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Allows to control basic funcitonalities of plaiframe.
*
* @requires plugin
* @requires medley
*
* @module control/control
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const plugin = require("../plugin.js")
const schema = require('./schema.json')
const medley = require('./../../medley.js')

/**
 * control this or remote sessions
 *
 * @class SessionControl
 * @extends {plugin.Plugin}
 */
class SessionControl extends plugin.Plugin {
  constructor() {
    super()
  }
  
  /**
   * Session control has no specific config requirements
   *
   * @param {Object} config
   * @returns {Object} - schema
   */
  setup(config) {
    super.setup(config)
    return schema
  }
  
  /**
   * forward cue data to control function
   *
   * @param {Object} data
   * @param {Object} session
   * @returns {Promise} - cue string or undefined returned by control function
   */
  cue(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "session":
            return resolve(this.control(data[item], session))
        }
      }
    })
  }
  
  /**
   *  execute one of the available session commands
   * 
   * - trigger next cue in this session
   * - quit this session (all further actions will fail. Next cues will not be found etc.)
   * - split a new path
   * - join an existing path and cancel its listeners
   * - launch another session
   * - cancel an external session
   *
   * @param {Object} data - see control schema for details
   * @param {Object} session - session context variables and functions
   * @returns {Promise} - next cue string or undefined. See schema for next property in each control action
   */
  control(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "next":
            return resolve(data[item])
          case "quit":
            this.game.deleteSession({"_id":session._id})
              .then(result => {
                return resolve(undefined)
              })
              .catch(err => {
                return reject(err)
              })
              break
          case "split":
            if(Array.isArray(data.split)) {
              for(let split of data.split) {
                this.split(split, session)
              }
            } else {
              this.split(data.split, session)
            }
            
            return resolve(undefined)
          case "join":
            // session.joinPath(data.join) // ignore since join depends on path list
            return resolve(undefined)
          case "launch":
            this.launchSession(data[item],session)
            .then(result => {
              return resolve(result)
            })
            .catch(error => {
              return reject(error)
            })
            break
          case "cancel":
            let session_ref = session.variables.getReference(data[item])
            if(session_ref) {
              this.game.deleteSession(session_ref.query)
              .then(result => {
                return resolve(undefined)
              })
              .catch(err => {
                return reject(err)
              })
            } else {
              return reject("Can not cancel session " + data[item] + ".")
            }
            break
        }
      }
    })
  }

  /**
   * call session splitPath function to split a new path. Create uid pathname if name is not provided.
   * @param {Object} path - path Details, next and name
   * @param {Object} session - session object
   */
  split(path, session) {
    if(path.hasOwnProperty('name')) {
      session.splitPath(path.next, path.name)
    } else {
      session.splitPath(path.next, generateUUID())
    }
  }

  /**
   * create new session
   * 
   * - review and assign arguments
   * - if there is a language property, use config.family and config.language keys to determine level.
   * - if language property does not resolve, defaults to level based on name
   * - create reference in this session referencing the new session
   * - dispatch next (if any) when done
   *
   * @param {Object} data
   * @param {string} data.level - level the session will be based upon
   * @param {Object} [data.arguments] - arguments to forward to new session
   * @param {string} [data.name] - name for new session document
   * @param {Object} session - session context variables and functions
   * @returns {Promise} - next cue string or undefined
   */
  launchSession(data, session) {
    return new Promise((resolve, reject) => {
      let new_session
      let level_query
      session.variables.review(data.level)
      .then(result => {
        if(!result) {
          throw new Error(data.level + " does not resolve to any value")
        }
        data.level = result

        if(data.language) {
          return session.variables.review(data.language)
        }
        return
      })
      .then(lan => {
        if(lan) {
          level_query = {
            "config.family":data.level,
            "config.language":lan
          }
        } else {
          level_query = {
            "name":data.level
          }
        }

        if(data.name) {
          return session.variables.review(data.name)
        }
        return
      })
      .then(name => {
        let args = {}

        for(let arg in data["arguments"]) {
          let arg_ref = session.variables.getReference(data["arguments"][arg])
          if(arg_ref) {
            args[arg] = {query:arg_ref.query, collection:arg_ref.collection}
          } else {
            log.warn(this.name, "couldn't assign argument '" + arg + "' when launching new session")
          }
        }

        if(name) {
          return this.game.createSession({"level":level_query, "arguments":args, "name":name})
        } else {
          return this.game.createSession({"level":level_query, "arguments":args})
        }
      })
      .then(result => {
        new_session = result
        session.variables.store({_id:new_session._id, name:new_session.name, "arguments":new_session.references})
      })
      .then(result => {
        if(data.hasOwnProperty("reference")) {
          return session.variables.review(data.reference)
        }
        return
      })
      .then(reference => {
        if(reference) {
          return session.createReference("sessions", {_id:new_session._id}, reference)
        }
        return
      })
      .then(result => {
        if(data.hasOwnProperty("next")) {
          return resolve(data.next)
        }
        return resolve()
      })
      .catch(error => {
        if(error == "session exists") {
          log.error(this.name, "couldn't launch session with name " + data.name + ". " + data.name + " already exists.")
        }
        return reject(error)
      })
    })
  }
}

module.exports.Plugin = SessionControl
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
